![Redaxscript](https://rawgithub.com/redaxmedia/media/master/svg/redaxscript.svg)


Redaxscript
===========

> Redaxscript is an ultra lightweight CMS, simplifying the world of complex online projects. Experience the future of web design and development - leave behind the confusion and build websites intuitively.

[![Build Status](https://travis-ci.org/redaxmedia/redaxscript.png?branch=master)](https://travis-ci.org/redaxmedia/redaxscript)
[![Scrutinizer Code Quality](https://scrutinizer-ci.com/g/redaxmedia/redaxscript/badges/quality-score.png?s=ba169d3afcf07f694959a6c2c5b0297be03ce752)](https://scrutinizer-ci.com/g/redaxmedia/redaxscript/)
[![Coverage Status](https://coveralls.io/repos/redaxmedia/redaxscript/badge.png)](https://coveralls.io/r/redaxmedia/redaxscript)
[![Dependency Status](https://www.versioneye.com/user/projects/5310e5a6ec13756c3e000314/badge.png)](https://www.versioneye.com/user/projects/5310e5a6ec13756c3e000314)
[![Dependency Status](https://www.versioneye.com/user/projects/5310e5aaec13756c3e00031b/badge.png)](https://www.versioneye.com/user/projects/5310e5aaec13756c3e00031b)
[![Latest Stable Version](https://poser.pugx.org/redaxmedia/redaxscript/v/stable.png)](https://packagist.org/packages/redaxmedia/redaxscript)
[![License](https://poser.pugx.org/redaxmedia/redaxscript/license.png)](https://packagist.org/packages/redaxmedia/redaxscript)


Online demo
-----------

> Unfortunately, no one can be told what Redaxscript is.
You have to see it for yourself.

You are going to experience limitations: [http://demo.redaxscript.com/login/demo](http://demo.redaxscript.com/login/demo)


Feature list
------------

* Simple installation wizard
* [Builds contents lightning fast](http://redaxscript.com/general/benchmark/page-load-time)
* **HTML5, CSS3, RSS2 and ATOM1 compliant**
* CSSLint, JSHint and HTMLHint validated
* Search engine friendly environment
* Fluide and elastic layout
* Mobile ready with responsive design
* On-demand loader for Javascript and CSS
* Pre-optimized with [Page Speed](http://redaxscript.com/general/benchmark/google-page-speed) and [Yslow](http://redaxscript.com/general/benchmark/yahoo-yslow)
* Intuitive WYSIWYE admin interface
* **Built-in frontend framework**
* Module system with hook points
* Advanced user and group permissions
* Bundled with the latest jQuery
* **Ultra lightweight WYSIWYG editor**
* Multiple language and template support
* Available in 30 languages
* Salt enhanced password security
* Extensive setting options


Search engine friendly
----------------------

* Canonical URL management to prevent duplicate content
* Robots management to prevent indexing of non-content pages
* **Search engine friendly URL** structure
* Unique meta description and meta keywords on each page
* Redirect www to non-www and remove trailing slashes
* [Sitemap XML](http://redaxscript.com/download/modules/sitemap-xml-module) module for search engines
* Unobtrusive Javascript
* Valid and sematic HTML markup


Our standards
-------------

* Use the Allman indent style
* Learn our naming and coding conventions
* Keep newlines and whitespaces
* Keep file and directory structure
* Follow seperation of concerns
* Build on modern web techniques
* Use our quality assurance tools


Related links
-------------

* [Website](http://redaxscript.com)
* [Download](http://redaxscript.com/download)
* [Support](http://redaxscript.com/support)
* [API](http://api.redaxscript.com)
* [Documentation](http://redaxscript.com/develop/documentation)
* [Community](http://redaxscript.com/community)
* [License](http://redaxscript.com/general/about/license)
